using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SMXLSLib;

namespace cs_XLSLib
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();

            tbFileName.Text = Application.StartupPath + "\\" + tbFileName.Text;

        }

        private void btnAbout_Click(object sender, EventArgs e)
        {
            ExcelReader.XLSAboutLib();
        }

        private void llHomePage_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            string url;
            if (e.Link.LinkData != null)
                url = e.Link.LinkData.ToString();
            else
                url = llHomePage.Text.Substring(e.Link.Start, e.Link.Length);

            System.Diagnostics.Process.Start(url);
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            ClearTabs();

            //ExcelReader xlse = new ExcelReader();
            IntPtr hXLS = ExcelReader.XLSOpenFileW(tbFileName.Text);

            int SheetCount = ExcelReader.XLSGetSheetCount(hXLS);
            for (int i=0; i < SheetCount; i++) {
                string SheetCaption = "";
                SheetCaption = SheetCaption.PadRight(255);
                int RowCount = 0, ColCount = 0;

                //read the sheet caption and row/col counts
                ExcelReader.XLSGetSheetInfo(hXLS, i, ref SheetCaption, 255, ref RowCount, ref ColCount);
                DataGridView grid = AddPageForSheet(SheetCaption, ColCount);

                //read all cells for sheet
                for (int j = 0; j < RowCount; j++)
                {
                    int RowNo = grid.Rows.Add();
                    DataGridViewRow row = grid.Rows[RowNo];
                    row.HeaderCell.Value = (RowNo+1).ToString();

                    for (int k = 0; k < ColCount; k++)
                    {
                        string arrTextCell = "";
                        arrTextCell = arrTextCell.PadRight(255);

                        ExcelReader.XLSGetCellValue(hXLS, i, j, k, 255, ref arrTextCell);
                        row.Cells[k].Value = arrTextCell;
                    }
                }
            }

            ExcelReader.XLSCloseFile(hXLS);

        }

        private void ClearTabs()
        {
            tcWorkbook.TabPages.Clear();
        }

        private string GetXLSColID(int Index)
        {
            string s = "";
            for (int i = Index; i > 0; i = (i - 1) / 25)
            {
                s = (char)(65 + (i-1)%25) + s;
            }
            return s;
        }

        private DataGridView AddPageForSheet(string SheetCaption, int ColCount)
        {
            //create new tab
            tcWorkbook.TabPages.Add(SheetCaption);
            TabPage tab = tcWorkbook.TabPages[tcWorkbook.TabPages.Count - 1];

            //add grid in tab
            DataGridView grid = new DataGridView();
            grid.AllowUserToAddRows = false;
            grid.AllowUserToDeleteRows = false;
            grid.ReadOnly = true;

            //add columns in grid
            grid.Columns.Clear();
            for (int i = 0; i < ColCount; i++)
            {
                grid.Columns.Add("Col" + i.ToString(), GetXLSColID(i+1));
            }

            tab.Controls.Add(grid);
            tab.Refresh();
            grid.Visible = true;
            grid.Dock = DockStyle.Fill;

            return grid;
        }
    }
}