using System;
using System.Runtime.InteropServices;

namespace SMXLSLib
{

    /// <summary>
    /// Summary description for ExcelReader
    /// </summary>
    public class ExcelReader
    {
        //file methods
        [DllImport("SMXLSLib.dll")]
        public static extern void XLSAboutLib();

        [DllImport("SMXLSLib.dll")]
        public static extern IntPtr XLSOpenFile([MarshalAs(UnmanagedType.LPStr)] string AFileName);

        [DllImport("SMXLSLib.dll")]
        public static extern IntPtr XLSOpenFileW([MarshalAs(UnmanagedType.LPWStr)] string AFileName);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSCloseFile(IntPtr AHandle);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetVersion(IntPtr AHandle);

        [DllImport("SMXLSLib.dll")]
        public static extern string XLSGetFileType(IntPtr AHandle);

        [DllImport("SMXLSLib.dll")]
        public static extern bool XLSIsEncrypted(IntPtr AHandle);

        //sheet methods
        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetSheetCount(IntPtr AHandle);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetSheetIndexByName(IntPtr AHandle, [MarshalAs(UnmanagedType.LPStr)] string SheetName);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetSheetIndexByNameW(IntPtr AHandle, [MarshalAs(UnmanagedType.LPWStr)] string SheetName);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetSheetInfo(IntPtr AHandle, int SheetIndex, [MarshalAs(UnmanagedType.LPStr)] ref string Caption, int MaxLen, ref int RowCount, ref int ColCount);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetSheetInfoW(IntPtr AHandle, int SheetIndex, [MarshalAs(UnmanagedType.LPWStr)] ref string Caption, int MaxLen, ref int RowCount, ref int ColCount);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetSheetNameLength(IntPtr AHandle, [MarshalAs(UnmanagedType.LPStr)] string SheetName);


        //cell methods
        public enum CellType
        {
            xctUnknown = 0,
            xctEmpty = 1,
            xctString = 2,
            xctInteger = 3,
            xctDecimal = 4,
            xctDateTime = 5,
            xctBoolean = 6,
            xctMemo = 7,
            xctDate = 8,
            xctTime = 9
        }

        [DllImport("SMXLSLib.dll")]
        public static extern CellType XLSGetCellType(IntPtr AHandle, int SheetIndex, int Row, int Column);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetCellValue(IntPtr AHandle, int SheetIndex, int Row, int Column, int MaxLen, [MarshalAs(UnmanagedType.LPStr)] ref string Value);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetCellValue_W(IntPtr AHandle, int SheetIndex, int Row, int Column, int MaxLen, [MarshalAs(UnmanagedType.LPWStr)] ref string Value);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetCellValueLength(IntPtr AHandle, int SheetIndex, int Row, int Column);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetCellAttr(IntPtr AHandle, int SheetIndex, int Row, int Column, [MarshalAs(UnmanagedType.LPStr)] ref string FormatMask, int FormatMaxLen, [MarshalAs(UnmanagedType.LPStr)] ref string FontName, int FontNameMaxLen, ref byte FontStyle, ref int FontSize, ref int FontColor, ref int Background, ref byte HorAlignment, ref byte VerAlignment);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetRangeValues(IntPtr AHandle, int SheetIndex, [MarshalAs(UnmanagedType.LPStr)] string Range, [MarshalAs(UnmanagedType.LPStr)] ref string Value);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetCellFormula(IntPtr AHandle, int SheetIndex, int Row, int Column, int MaxLen, [MarshalAs(UnmanagedType.LPStr)] ref string Value);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetCellFormulaLength(IntPtr AHandle, int SheetIndex, int Row, int Column);

        [DllImport("SMXLSLib.dll")]
        public static extern bool XLSIsCellFormula(IntPtr AHandle, int SheetIndex, int Row, int Column);

        //width/height
        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetColumnWidth(IntPtr AHandle, int SheetIndex, int Column);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetRowHeight(IntPtr AHandle, int SheetIndex, int Row);

        //named ranges
        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetNamedRangeCount(IntPtr AHandle);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetNamedRangeLength(IntPtr AHandle, int Index, ref int NameLen, ref int FormulaLen);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetNamedRangeInfo(IntPtr AHandle, int Index, [MarshalAs(UnmanagedType.LPStr)] ref string Name, int NameLen, [MarshalAs(UnmanagedType.LPStr)] ref string Formula, int FormulaLen);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetNamedRangeInfo_W(IntPtr AHandle, int Index, [MarshalAs(UnmanagedType.LPWStr)] ref string Name, int NameLen, [MarshalAs(UnmanagedType.LPWStr)] ref string Formula, int FormulaLen);

        //save to file
        [DllImport("SMXLSLib.dll")]
        public static extern void XLSConvertToCSV([MarshalAs(UnmanagedType.LPStr)] string XLSFileName, [MarshalAs(UnmanagedType.LPStr)] string CSVFileName, [MarshalAs(UnmanagedType.LPStr)] string FieldDelimiter, [MarshalAs(UnmanagedType.LPStr)] string TextQualifier, int SheetIndex);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSConvertToHTML([MarshalAs(UnmanagedType.LPStr)] string XLSFileName, [MarshalAs(UnmanagedType.LPStr)] string HTMLFileName, int SheetIndex);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSConvertToXML([MarshalAs(UnmanagedType.LPStr)] string XLSFileName, [MarshalAs(UnmanagedType.LPStr)] string XMLFileName, int SheetIndex);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSConvertToExcelXML([MarshalAs(UnmanagedType.LPStr)] string XLSFileName, [MarshalAs(UnmanagedType.LPStr)] string XMLFileName, int SheetIndex);

        [DllImport("SMXLSLib.dll")]
        public static extern void XLSConvertToLotus123([MarshalAs(UnmanagedType.LPStr)] string XLSFileName, [MarshalAs(UnmanagedType.LPStr)] string WKSFileName, int SheetIndex);

        //summary information
        [DllImport("SMXLSLib.dll")]
        public static extern void XLSGetSummaryInformation(IntPtr AHandle, [MarshalAs(UnmanagedType.LPStr)] ref string Info, int MaxLen);

        [DllImport("SMXLSLib.dll")]
        public static extern int XLSGetSummaryInformationLength(IntPtr AHandle);

        public ExcelReader()
        {
            //
            // TODO: Add constructor logic here
            //
        }
    }
}