// MFC_XLSLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC_XLSLib.h"
#include "MFC_XLSLibDlg.h"
#include "SMXLSLib.h"
#include "dSheetPage.h"
#include "XLSRange.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MaxPages 100
CPropertyPage *tabpages[MaxPages];


/////////////////////////////////////////////////////////////////////////////
// CMFC_XLSLibDlg dialog

CMFC_XLSLibDlg::CMFC_XLSLibDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFC_XLSLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFC_XLSLibDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_XLSLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFC_XLSLibDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFC_XLSLibDlg, CDialog)
	//{{AFX_MSG_MAP(CMFC_XLSLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDABOUT, OnAbout)
	ON_BN_CLICKED(IDLOAD, OnLoad)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TABSHEET, OnSelchangeTabsheet)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RANGE, OnRange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFC_XLSLibDlg message handlers

BOOL CMFC_XLSLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// fill default xls-filename
	GetDlgItem(IDC_FILENAME)->SetWindowText(_T("orders.xls")); 

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFC_XLSLibDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFC_XLSLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFC_XLSLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFC_XLSLibDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);
	ShellExecute(NULL, _T("open"), "http://www.scalabium.com/xls/xlslib.htm", NULL,NULL, SW_SHOW);
}

void CMFC_XLSLibDlg::OnAbout() 
{
  XLSAboutLib();
}

void CMFC_XLSLibDlg::OnLoad() 
{
	int i = 0;
    
	//delete all sheets
	CTabCtrl* tab = (CTabCtrl*) GetDlgItem(IDC_TABSHEET); 
	tab->DeleteAllItems();
    //destroy all existing pages/dialogs
	for (i = 0; i < MaxPages; i++) { 
       if (tabpages[i] != NULL) 
          delete tabpages[i]; 
	} 
	tab->ShowWindow(SW_HIDE);

	// get xls-filename
	CString str;
	GetDlgItem(IDC_FILENAME)->GetWindowText(str); 
	LPCTSTR AFileName = str.GetBuffer(255);
	str.ReleaseBuffer();

	//open xls-file
    THandle xlsHandle = XLSOpenFile(AFileName);
	
    //get the sheet count
    int intSheetCount = XLSGetSheetCount(xlsHandle);

    int intRowCount = 0, intColCount = 0;
		
	LPSTR arrSheetText;
	for (i=0; (i<intSheetCount); i++) {
      int n = XLSGetSheetNameLength(xlsHandle, i);
	  arrSheetText = new char[n+1]; 

	  //get the sheet name/colcount/rowcount for every sheet
	  XLSGetSheetInfo(xlsHandle, i, arrSheetText, n, intRowCount, intColCount);

	  //insert new tab for sheet
	  tab->InsertItem(i, arrSheetText);
  	  delete arrSheetText;

  	  tabpages[i] = new CPropertyPage();
	  tabpages[i]->Create(IDD_PROPPAGE, GetParent());
	  tab->ShowWindow(SW_SHOW);

	  //for sheet we'll load cell contents into editbox
	  CEdit* memo = (CEdit*) tabpages[i]->GetDlgItem(IDC_SHEETDATA);
	  CString str;
		  
	  //iterate thru rows
	  for (int j=0; (j<intRowCount); j++) {
  	    //iterate thru columns in row
		  for (int k=0; (k<intColCount); k++) {
			//get the length for value in cell and allocate the memory
			n = XLSGetCellValueLength(xlsHandle, i, j, k);
			
			if (n > 0) {
				LPSTR arrTextCell = new char[n+1]; 
				//get the value
				XLSGetCellValue(xlsHandle, i, j, k, n, arrTextCell);				

				str += arrTextCell; 
				str += "\t"; 
				//free the memory
				delete arrTextCell;
			}
		}
		str += "\r\n"; 
	  }
	  //copy the sheet contents into editbox
	  memo->SetWindowText(str);
	}

	//activate the first tab
	tab->SetCurSel(0);
	NMHDR nmhdr; 
	nmhdr.hwndFrom=tab->GetSafeHwnd(); 
	nmhdr.idFrom=0; // if button is on tab 0 
	nmhdr.code=TCN_SELCHANGE; 
	SendMessage(WM_NOTIFY,IDC_TABSHEET,(LPARAM)&nmhdr); 

	for (i=intSheetCount+1; (i<MaxPages); i++)
		tabpages[i] = NULL;

	//close xls-file
	XLSCloseFile(xlsHandle);
}

void CMFC_XLSLibDlg::OnSelchangeTabsheet(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// show/hide the current child dialog box 
	CTabCtrl* tab = (CTabCtrl*) GetDlgItem(IDC_TABSHEET); 
	int iCurSel = tab->GetCurSel();
	for (int i = 0; i < MaxPages; i++)
		if (tabpages[i] != NULL) 
			tabpages[i]->ShowWindow(i == iCurSel ? SW_SHOW : SW_HIDE);

    *pResult = 0;
}

void CMFC_XLSLibDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	//destroy all existing pages
	for (int i = 0; i < MaxPages; i++) { 
		if (tabpages[i] != NULL) 
			delete tabpages[i]; 
	} 
	
}

void CMFC_XLSLibDlg::OnRange() 
{
	XLSRange *xlsr = new XLSRange;
  
	xlsr->DoModal();

	delete xlsr;

}
