{ Reader Engine for Excel files (DLL edition)
  header file for Borland Delphi

  Copyright (C) 2000-2022, written by Shkolnik Mike, Scalabium Software
  E-Mail:  xlslib@scalabium.com
  WEB: http://www.scalabium.com/xls/xlslib.htm
}
unit SMXLSLib;

interface

uses Windows;

procedure XLSAboutLib; cdecl; external 'smxlslib.dll';

{file methods}
function XLSOpenFile(AFileName: PAnsiChar): THandle; cdecl; external 'smxlslib.dll';
function XLSOpenFileW(AFileName: PWideChar): THandle; cdecl; external 'smxlslib.dll';
procedure XLSCloseFile(AHandle: THandle); cdecl; external 'smxlslib.dll';
function XLSGetVersion(AHandle: THandle): Integer; cdecl; external 'smxlslib.dll';
function XLSGetFileType(AHandle: THandle): PAnsiChar; cdecl; external 'smxlslib.dll';
function XLSIsEncrypted(AHandle: THandle): Boolean; cdecl; external 'smxlslib.dll';

{sheet methods}
function XLSGetSheetCount(AHandle: THandle): Integer; cdecl; external 'smxlslib.dll';
function XLSGetSheetIndexByName(AHandle: THandle; SheetName: PAnsiChar): Integer; cdecl; external 'smxlslib.dll';
function XLSGetSheetIndexByNameW(AHandle: THandle; SheetName: PWideChar): Integer; cdecl; external 'smxlslib.dll';
procedure XLSGetSheetInfo(AHandle: THandle; SheetIndex: Integer; var Caption: PAnsiChar; MaxLen: Integer; var RowCount, ColCount: Integer); cdecl; external 'smxlslib.dll';
procedure XLSGetSheetInfoW(AHandle: THandle; SheetIndex: Integer; var Caption: PWideChar; MaxLen: Integer; var RowCount, ColCount: Integer); cdecl; external 'smxlslib.dll';
function XLSGetSheetNameLength(AHandle: THandle; SheetIndex: Integer): Integer; cdecl; external 'smxlslib.dll';

{cell methods}
function XLSGetCellType(AHandle: THandle; SheetIndex, Row, Col: Integer): Integer; cdecl; external 'smxlslib.dll';
procedure XLSGetCellValue(AHandle: THandle; SheetIndex, Row, Col, MaxLen: Integer; var Value: PAnsiChar); cdecl; external 'smxlslib.dll';
procedure XLSGetCellValueW(AHandle: THandle; SheetIndex, Row, Col, MaxLen: Integer; var Value: PWideChar); cdecl; external 'smxlslib.dll';
function XLSGetCellValueLength(AHandle: THandle; SheetIndex, Row, Col: Integer): Integer; cdecl; external 'smxlslib.dll';
procedure XLSGetCellAttr(AHandle: THandle; SheetIndex, Row, Col: Integer; var AFormatMask: PAnsiChar; FormatMaxLen: Integer; var AFontName: PAnsiChar; FontNameMaxLen: Integer; var AFontStyle: Byte; var AFontSize: Integer; var AFontColor: Integer; var ABackground: Integer; var AHorAlignment: Byte; var AVerAlignment: Byte); cdecl; external 'smxlslib.dll';
procedure XLSGetRangeValues(AHandle: THandle; SheetIndex: Integer; const Range: PAnsiChar; var Value: Variant); cdecl; external 'smxlslib.dll';
procedure XLSGetCellFormula(AHandle: THandle; SheetIndex, Row, Col, MaxLen: Integer; var Value: PAnsiChar); cdecl; external 'smxlslib.dll';
function XLSGetCellFormulaLength(AHandle: THandle; SheetIndex, Row, Col: Integer): Integer; cdecl; external 'smxlslib.dll';
function XLSIsCellFormula(AHandle: THandle; SheetIndex, Row, Col: Integer): Boolean; cdecl; external 'smxlslib.dll';

{width/height}
function XLSGetColumnWidth(AHandle: THandle; SheetIndex, Col: Integer): Integer; cdecl; external 'smxlslib.dll';
function XLSGetRowHeight(AHandle: THandle; SheetIndex, Row: Integer): Integer; cdecl; external 'smxlslib.dll';

{named ranges}
function XLSGetNamedRangeCount(AHandle: THandle): Integer; cdecl; external 'smxlslib.dll';
procedure XLSGetNamedRangeLength(AHandle: THandle; Index: Integer; var NameLen, FormulaLen: Integer); cdecl; external 'smxlslib.dll';
procedure XLSGetNamedRangeInfo(AHandle: THandle; Index: Integer; var Name: PAnsiChar; NameLen: Integer; var Formula: PAnsiChar; FormulaLen: Integer); cdecl; external 'smxlslib.dll';
procedure XLSGetNamedRangeInfo_W(AHandle: THandle; Index: Integer; var Name: PWideChar; NameLen: Integer; var Formula: PWideChar; FormulaLen: Integer); cdecl; external 'smxlslib.dll';

{save to file}
procedure XLSConvertToCSV(const XLSFileName, CSVFileName, FieldDelimiter, TextQualifier: PAnsiChar; ASheetIndex: Integer); cdecl; external 'smxlslib.dll';
procedure XLSConvertToHTML(const XLSFileName, HTMLFileName: PAnsiChar; ASheetIndex: Integer); cdecl; external 'smxlslib.dll';
procedure XLSConvertToXML(const XLSFileName, XMLFileName: PAnsiChar; ASheetIndex: Integer); cdecl; external 'smxlslib.dll';
procedure XLSConvertToExcelXML(const XLSFileName, XMLFileName: PAnsiChar; ASheetIndex: Integer); cdecl; external 'smxlslib.dll';
procedure XLSConvertToLotus123(const XLSFileName, WKSFileName: PAnsiChar; ASheetIndex: Integer); cdecl; external 'smxlslib.dll';
procedure XLSConvertToXLSX(const XLSFileName, TargetFileName: PChar; ASheetIndex: Integer); cdecl; external 'smxlslib.dll';

{summary information}
procedure XLSGetSummaryInformation(AHandle: THandle; var Info: PAnsiChar; MaxLen: Integer); cdecl; external 'smxlslib.dll';
function XLSGetSummaryInformationLength(AHandle: THandle): Integer; cdecl; external 'smxlslib.dll';

//cell types, returned in XLSGetCellType
const
  xctUnknown  = 0;
  xctEmpty    = 1;
  xctString   = 2;
  xctInteger  = 3;
  xctDecimal  = 4;
  xctDateTime = 5;
  xctBoolean  = 6;
  xctMemo     = 7;
  xctDate     = 8;
  xctTime     = 9;

implementation

end.
